#include <string.h>
#include <stdlib.h>  
#include <stdio.h>  
#include <math.h>
#include <time.h>
#include <assert.h>

#include <GL/glut.h>
#include "asteroids.h"

static GLfloat blueMaterial[] = {0.0, 0.2, 1.0, 1.0},
  redMaterial[] = {0.9, 0.2, 0.2, 1.0},
  purpleMaterial[] = {0.3, 0.0, 0.3, 1.0},
  greenMaterial[] = {1.0, 0.2, 0.0, 1.0},
  whiteMaterial[] = {1.0, 1.0, 1.0, 1.0};


int Angle=0;
float xx=0,yy=0;
int W,H;

float RandFactor(Point3f *p1, Point3f *p2,int seed)
{
	srand48(seed+(int)((p1->x+p2->x)*112334+(p1->y+p2->y)*76253+(p1->z+p2->z)*151234));
	return (float)(drand48()-0.5f);
}

void MidPoint2(Point3f *d,Point3f *p1, Point3f *p2,
			   float Scale, float PowExp,int seed)
{
 float r,rd,l,dl;
 Point3f p;
 Point3f dp;
 
 dp.x=p1->x - p2->x;  dp.y=p1->y - p2->y;  dp.z=p1->z - p2->z;
 dl=Lenght(&dp);

 d->x=(p1->x + p2->x)/2;  d->y=(p1->y + p2->y)/2;  d->z=(p1->z + p2->z)/2;
 p.x=p1->x-p2->x; p.y=p1->y-p2->y;  p.z=p1->z-p2->z;
 
 l=pow(Lenght(&p),PowExp)*RandFactor(p1,p2,seed)/Scale;
 
 r=(1.0+l)*(Lenght(p1)+Lenght(p2))/2;
 rd=Lenght(d);
 assert(rd>0);
 
 d->x = (d->x*r/rd)+RandFactor(p1,p2,seed+100)*(dl*.2);
 d->y = (d->y*r/rd)+RandFactor(p1,p2,seed+200)*(dl*.2);
 d->z = (d->z*r/rd)+RandFactor(p1,p2,seed+300)*(dl*.2);
}


void Fract2(int level, Point3f *p1, Point3f *p2, Point3f *p3,float Scale, float PowExp,int seed)
{
 Point3f m1,m2,m3,n;

 if(level==0)
	{
	 FaceNormal(&n,p1,p2,p3);
	 //glBegin(GL_LINE_LOOP);
	 //glBegin(GL_TRIANGLES);
	  glNormal3f(n.x,n.y,n.z);
	  glVertex3f(p1->x,p1->y,p1->z);
	  glVertex3f(p2->x,p2->y,p2->z);
	  glVertex3f(p3->x,p3->y,p3->z);
	 //glEnd();
	}
 else
	{
	 MidPoint2(&m1,p1,p2,Scale,PowExp,seed);
	 MidPoint2(&m2,p2,p3,Scale,PowExp,seed);
	 MidPoint2(&m3,p3,p1,Scale,PowExp,seed);
	 Fract2(level-1, p1,&m1,&m3,Scale,PowExp,seed);
	 Fract2(level-1, p2,&m2,&m1,Scale,PowExp,seed);
	 Fract2(level-1, p3,&m3,&m2,Scale,PowExp,seed);
	 Fract2(level-1,&m1,&m2,&m3,Scale,PowExp,seed);
	}
}



int CreateAsteroid(int level,float Scale, float PowExp,int seed)
{
	Point3f p1,p2,p3,p4,p5,p6;
	
	p1.x=  0; p1.y= 1; p1.z= 0;
	p2.x=  1; p2.y= 0; p2.z= 0;
	p3.x=  0; p3.y= 0; p3.z=-1;
	p4.x= -1; p4.y= 0; p4.z= 0;
	p5.x=  0; p5.y= 0; p5.z= 1;
	p6.x=  0; p6.y=-1; p6.z= 0;

	printf("\n\n");
	glMaterialfv(GL_FRONT, GL_DIFFUSE, whiteMaterial);
	glBegin(GL_TRIANGLES);
	Fract2(level, &p1, &p2, &p3,Scale,PowExp,seed);
	Fract2(level, &p1, &p3, &p4,Scale,PowExp,seed);
	Fract2(level, &p1, &p4, &p5,Scale,PowExp,seed);
	Fract2(level, &p1, &p5, &p2,Scale,PowExp,seed);
	Fract2(level, &p6, &p3, &p2,Scale,PowExp,seed);
	Fract2(level, &p6, &p4, &p3,Scale,PowExp,seed);
	Fract2(level, &p6, &p5, &p4,Scale,PowExp,seed);
	Fract2(level, &p6, &p2, &p5,Scale,PowExp,seed);
	glEnd();
	
return 1;
}



